#pragma once

extern "C" {
# include <liblocky.h>
}

#include <cstdint>
#include <iostream>
#include <tuple>
#include <unordered_map>
#include <vector>


namespace blky {

enum DataFlow {
  kBytes,
  kFeatures,
  kVideo,
};

static inline const std::string kDataFlowList = "bytes/features/video";
static inline const std::unordered_map<std::string, DataFlow> kDataFlowMap = {
  {"bytes",    kBytes},
  {"features", kFeatures},
  {"video",    kVideo},
};


struct Feature final {
  uint64_t index;
  uint64_t begin;
  uint64_t end;
};


auto& operator<<(auto& ost, const Feature& feat) {
  ost << feat.index << " " << feat.begin << " " << feat.end;
  return ost;
}
auto& operator>>(auto& ist, Feature& feat) {
  ist >> feat.index >> feat.begin >> feat.end;
  return ist;
}

}  // namespace blky


namespace args {

auto& operator>>(auto& ist, std::tuple<uint32_t, uint32_t>& v) {
  ist >> std::get<0>(v) >> std::get<1>(v);
  return ist;
}

}  // namespace args
